SystemOrganization addCategory: #SqueakSVN!
SystemOrganization addCategory: #'SqueakSVN-AcceptanceTests'!
SystemOrganization addCategory: #'SqueakSVN-Base'!
SystemOrganization addCategory: #'SqueakSVN-Base-Test'!
SystemOrganization addCategory: #'SqueakSVN-Plugins'!
SystemOrganization addCategory: #'SqueakSVN-Serializing'!
SystemOrganization addCategory: #'SqueakSVN-Serializing-Test'!
SystemOrganization addCategory: #'SqueakSVN-Test'!
SystemOrganization addCategory: #'SqueakSVN-UI-Models'!
SystemOrganization addCategory: #'SqueakSVN-UI-Tools'!

Model subclass: #SVNCreateProjectDialog
	instanceVariableNames: 'name url builder widget wcPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNCreateProjectDialog class methodsFor: 'as yet unclassified' stamp: 'cop 2/26/2008 14:04'!
open
	| instance |			
	instance := self new.
	ToolBuilder default open: instance.
	^instance! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 09:04'!
alwaysTrue
	^true! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 12:12'!
buildWith: aBuilder
	| windowSpec okButton cancelButton nameField urlField wcField |
	builder := aBuilder.
	windowSpec := (builder pluggableWindowSpec new)
				extent: 300 @ 180;
				model: self;
				label: 'Create a SVNProject';
				children: OrderedCollection new.
				
	nameField := (builder pluggableInputFieldSpec new)
				model: self;
				getText: #getName;
				setText: #setName:;
				frame: (0 @ 0 corner: 1 @ 0.266).
				
	urlField := (builder pluggableInputFieldSpec new)
				model: self;
				getText: #getURL;
				setText: #setURL:;
				frame: (0 @ 0.266 corner: 1 @ 0.533).
				
	wcField := (builder pluggableInputFieldSpec new)
				model: self;
				getText: #getWCPath;
				setText: #setWCPath:;
				frame: (0 @ 0.533 corner: 1 @ 0.8).
				
	okButton := (builder pluggableButtonSpec new)
				model: self;
				label: #okButtonLabel;
				action: #createProject;
				color: #greenColor;
				state: #canAccept;
				frame: (0 @ 0.8 corner: 0.5 @ 1).
				
	cancelButton := (builder pluggableButtonSpec new)
				model: self;
				label: #cancelButtonLabel;
				action: #close;
				color: #redColor;
				state: #alwaysTrue;
				frame: (0.5 @ 0.8 corner: 1 @ 1).
				
	windowSpec children add: nameField.
	windowSpec children add: urlField.
	windowSpec children add: wcField.
	windowSpec children add: okButton.
	windowSpec children add: cancelButton.
	windowSpec frame: (0 @ 0 corner: 1 @ 1).
	^ widget := builder build: windowSpec! !

!SVNCreateProjectDialog methodsFor: 'functionality' stamp: 'cop 2/26/2008 15:10'!
canAccept
	^(name = self defaultName) not! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/26/2008 13:07'!
cancelButtonLabel
	^'Cancel'! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/26/2008 14:11'!
close
	builder close: widget! !

!SVNCreateProjectDialog methodsFor: 'functionality' stamp: 'cop 2/28/2008 12:05'!
createProject
	| aSVNProject |
	self canAccept ifFalse: [^nil].
	
	aSVNProject := ((SVNProject named: name)
		repositoryURL: (Url absoluteFromText: url asString);
		yourself).
	wcPath = self defaultWCPath ifFalse: [ aSVNProject workingCopyDirectory: (SVNDirectory on: wcPath asString) ].
	self changed: #newProject with: aSVNProject.
	self close.! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/26/2008 15:02'!
defaultName
	^'Insert the project name here.'! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/26/2008 15:02'!
defaultURL
	^'Insert the repository URL here'! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 12:03'!
defaultWCPath
	^'Insert the working copy path here'! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'cop 2/26/2008 15:06'!
getName
	^name! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'cop 2/26/2008 15:01'!
getURL
	^url! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'cop 2/28/2008 12:02'!
getWCPath
	^wcPath! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 09:03'!
greenColor
	^Color green! !

!SVNCreateProjectDialog methodsFor: 'initialize-release' stamp: 'cop 2/28/2008 12:13'!
initialize
	super initialize.
	name := self defaultName.
	url := self defaultURL.
	wcPath := self defaultWCPath.! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/26/2008 13:07'!
okButtonLabel
	^'Create project'! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 08:47'!
redColor
	^Color red! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'cop 2/26/2008 15:06'!
setName: aString
	aString = self defaultName ifFalse: [ name := aString.
											^true ] ifTrue: [ ^false]! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'cop 2/26/2008 15:06'!
setURL: aString
	aString = self defaultURL ifFalse: [ url := aString.
											^true ] ifTrue: [ ^false]! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'cop 2/28/2008 12:03'!
setWCPath: aString
	aString = self defaultWCPath ifFalse: [ wcPath := aString.
											^true ] ifTrue: [ ^false]! !

Model subclass: #SVNDialog
	instanceVariableNames: 'builder widget selector title text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

SVNDialog subclass: #SVNAddClassDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNAddClassDialog class methodsFor: 'as yet unclassified' stamp: 'cop 2/27/2008 12:08'!
open
	| instance |			
	instance := self new.
	ToolBuilder default open: instance.
	^instance! !

!SVNAddClassDialog methodsFor: 'functionality' stamp: 'cop 2/28/2008 12:42'!
addClassName
	| class |
	class := SystemDictionary new classNamed: text asString.
	class ifNil:[^nil].
	self changed: #addClass with: class.
	self close.! !

!SVNAddClassDialog methodsFor: 'functionality' stamp: 'cop 2/28/2008 11:55'!
canAccept: aString
	(SystemDictionary new classNamed: aString asString )
		ifNil:[^false]
		ifNotNil: [^true].! !

!SVNAddClassDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 12:43'!
dialogSelector
	^#addClass! !

!SVNAddClassDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 11:52'!
dialogTitle
	^'Add class to SVNProject'! !

!SVNDialog class methodsFor: 'open' stamp: 'cop 2/28/2008 11:58'!
openWith: aString
	| instance |			
	instance := self new
			text: aString;
			yourself.
	ToolBuilder default open: instance.
	^instance! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:46'!
alwaysTrue
	^true! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 11:56'!
buildWith: aBuilder
	| windowSpec okButton cancelButton stringField |
	builder := aBuilder.
	windowSpec := (builder pluggableWindowSpec new)
				extent: 300 @ 60;
				model: self;
				label: self dialogTitle;
				children: OrderedCollection new.
							
	stringField := (builder pluggableInputFieldSpec new)
				model: self;
				getText: #text;
				setText: #text:;
				frame: (0 @ 0 corner: 1 @ 0.5).
				
	okButton := (builder pluggableButtonSpec new)
				model: self;
				label: #okButtonLabel;
				action: #editedText;
				color: #greenColor;
				state: #canAccept;
				frame: (0 @ 0.5 corner: 0.5 @ 1).
				
	cancelButton := (builder pluggableButtonSpec new)
				model: self;
				label: #cancelButtonLabel;
				action: #close;
				color: #redColor;
				state: #alwaysTrue;
				frame: (0.5 @ 0.5 corner: 1 @ 1).
				
	windowSpec children add: stringField.
	windowSpec children add: okButton.
	windowSpec children add: cancelButton.
	windowSpec frame: (0 @ 0 corner: 1 @ 1).
	^ widget := builder build: windowSpec! !

!SVNDialog methodsFor: 'functionality' stamp: 'cop 2/28/2008 11:55'!
canAccept
	^ self canAccept: text! !

!SVNDialog methodsFor: 'functionality' stamp: 'cop 2/28/2008 11:56'!
canAccept: aText
	aText ifNil: [^false]
		ifNotNil: [^true]! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:46'!
cancelButtonLabel
	^'Cancel'! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:46'!
close
	builder close: widget! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:55'!
dialogSelector
	^self subclassResponsibility ! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:55'!
dialogTitle
	^self subclassResponsibility ! !

!SVNDialog methodsFor: 'functionality' stamp: 'cop 2/28/2008 11:56'!
editedText
	self canAccept 
		ifTrue: 
			[self changed: self dialogSelector with: text.
			self close]! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:46'!
greenColor
	^Color green! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 11:25'!
okButtonLabel
	^'Ok'! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:46'!
redColor
	^Color red! !

!SVNDialog methodsFor: 'accessing' stamp: 'cop 2/28/2008 10:50'!
selector: aSelector
	selector := aSelector! !

!SVNDialog methodsFor: 'accessing' stamp: 'cop 2/28/2008 11:55'!
text
	^ text! !

!SVNDialog methodsFor: 'accessing' stamp: 'cop 2/28/2008 11:56'!
text: aText
	(self canAccept: aText) ifFalse: [^ false].
	text := aText.
	^ true! !

SVNDialog subclass: #SVNSetURLDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNSetURLDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:59'!
dialogSelector
	^#editedURL! !

!SVNSetURLDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:58'!
dialogTitle
	^'Edit SVNProject URL'! !

SVNDialog subclass: #SVNSetWCPathDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNSetWCPathDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:59'!
dialogSelector
	^#editedWCPath! !

!SVNSetWCPathDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:58'!
dialogTitle
	^'Edit working copy path'! !

Model subclass: #SVNProjectBrowser
	instanceVariableNames: 'projectNodes selectedNode browserMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cop 2/26/2008 13:51'!
open
	^self openOn: (SVNProject allInstances asOrderedCollection )! !

!SVNProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cop 2/26/2008 14:03'!
openOn: aCollection
	| instance |	
	instance :=( self new)
				setListOfProjectNodes: aCollection.
	ToolBuilder default open: instance.
	^instance! !

!SVNProjectBrowser methodsFor: 'ui' stamp: 'cop 2/28/2008 09:04'!
alwaysTrue
	^true! !

!SVNProjectBrowser methodsFor: 'ui' stamp: 'cop 2/28/2008 09:17'!
buildWith: builder 
	| windowSpec treeSpec createButton |
	windowSpec := (builder pluggableWindowSpec new)
				extent: 500 @ 400;
				model: self;
				label: 'SqueakSVN Project Browser';
				closeAction: #closeWindow;
				children: OrderedCollection new.
				
	treeSpec := (builder pluggableTreeSpec new)
				model: self;
				roots: #listOfProjectNodes;
				hasChildren: #nodeHasChildren:;
				getChildren: #getChildrenOfNode:;
				label: #labelOfNode:;
				menu: #menuOn:;
				getSelectedPath: #getPathToSelectedNode;
				setSelected: #setSelectedNode:;
				frame: (0 @ 0 corner: 0.33 @ 0.9).
				
	createButton := (builder pluggableButtonSpec new)
				model: self;
				label: #createButtonLabel;
				action: #createProject;
				color: #grayColor;
				state: #alwaysTrue;
				frame: (0 @ 0.9 corner: 0.2 @ 1).
				
	windowSpec children add: treeSpec.
	windowSpec children add: createButton.
	self flag: #TODO.
	browserMorph := builder build: windowSpec.
	^ browserMorph! !

!SVNProjectBrowser methodsFor: 'ui' stamp: 'cop 2/28/2008 09:51'!
closeWindow
	"Free the pointers to prevent pointer cycle"
	projectNodes := OrderedCollection new.
	selectedNode := nil.
	browserMorph := nil.! !

!SVNProjectBrowser methodsFor: 'ui' stamp: 'cop 2/26/2008 15:59'!
createButtonLabel
	^'Create project'! !

!SVNProjectBrowser methodsFor: 'functionality' stamp: 'cop 2/27/2008 10:42'!
createProject
	SVNCreateProjectDialog open myDependents: (Array with: self)! !

!SVNProjectBrowser methodsFor: 'menus' stamp: 'cop 2/26/2008 16:36'!
defaultMenuOn: aMenu
	"aMenu label: 'Manage projects'."
	aMenu add: 'Create Project' action: #createProject.
	^aMenu! !

!SVNProjectBrowser methodsFor: 'node handling' stamp: 'cop 2/26/2008 11:39'!
getChildrenOfNode: aNode 
	^ aNode getChildren! !

!SVNProjectBrowser methodsFor: 'node handling' stamp: 'cop 2/27/2008 16:56'!
getPathToSelectedNode
	| aCollection aNode |
	aNode := selectedNode.
	aCollection := OrderedCollection new.
	[aNode isNil not ] whileTrue: [aCollection addLast: aNode.
									aNode := aNode parent. ].
	^ aCollection! !

!SVNProjectBrowser methodsFor: 'ui' stamp: 'cop 2/28/2008 10:10'!
grayColor
	^Color gray ! !

!SVNProjectBrowser methodsFor: 'node handling' stamp: 'cop 2/26/2008 11:53'!
labelOfNode: aNode 
	^ aNode getLabel! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'cop 2/26/2008 15:40'!
listOfProjectNodes
	^projectNodes! !

!SVNProjectBrowser methodsFor: 'menus' stamp: 'cop 2/27/2008 13:30'!
menuOn: aMenu 
	self getPathToSelectedNode isEmpty ifTrue: [^ self defaultMenuOn: aMenu].
	^ self getPathToSelectedNode first getMenuOn: aMenu! !

!SVNProjectBrowser methodsFor: 'node handling' stamp: 'cop 2/26/2008 11:52'!
nodeHasChildren: aNode 
	^ (self getChildrenOfNode: aNode) notEmpty! !

!SVNProjectBrowser methodsFor: 'message handling' stamp: 'cop 2/26/2008 12:41'!
perform: selector orSendTo: otherTarget
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'cop 2/27/2008 16:49'!
setListOfProjectNodes: aCollection
	projectNodes := aCollection collect: [ :each | (SVNProjectNode element: each)
												myDependents: (Array with: self). ]! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'cop 2/27/2008 13:25'!
setSelectedNode: aNode 
	selectedNode := aNode! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 2/28/2008 12:46'!
update: aSelector
	aSelector == #updateTree ifTrue: [ self updateTree. ^self ].	
	super update: aSelector.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 2/28/2008 13:23'!
update: aSelector with: anObject
	aSelector == #newProject ifTrue: [
								projectNodes add: ((SVNProjectNode element: anObject) myDependents: (Array with: self)).
								self updateTree.
								^self].
	aSelector == 	#deleteMe ifTrue: [ projectNodes remove: anObject.
									self updateTree. ^self ].	
	super update: aSelector with: anObject.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 2/27/2008 13:33'!
updateTree
	self flag: #TODO.
	browserMorph submorphs do: [:each | each update: #listOfProjectNodes].
	browserMorph submorphs do: [:each | each update: #getPathToSelectedNode]! !

Object subclass: #SVNClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNClient subclass: #SVNCApiClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnAdd: pathToTarget

	<primitive: 'svnAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 2/22/2008 11:55'!
basicSvnAddProperty: property WithValue:value To: target
 
	<primitive: 'svnAddPropertyWithValueTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:31'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath
 
	<primitive: 'svnCheckoutHeadRevisionFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:34'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	<primitive: 'svnCheckoutRevisionByNumberFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:15'!
basicSvnCommit: collectionOfPathesToTargets
 
	<primitive: 'svnCommit' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnGetHeadRevision: pathToTarget

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/27/2008 00:06'!
basicSvnGetPropertiesFrom: target
 
	<primitive: 'svnGetPropertiesFrom' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 2/25/2008 09:03'!
basicSvnGetProperty: property From: target
 
	<primitive: 'svnGetPropertyFrom' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:18'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber
 
	<primitive: 'svnUpdateTargetsToRevisionByNumber' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:16'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets
 
	<primitive: 'svnUpdateTargetsToHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:56'!
basicSvnAdd: aPath

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'pe 2/22/2008 11:54'!
basicSvnAddProperty: property WithValue:value To: target

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:31'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:35'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:57'!
basicSvnCommit: collectionOfPathsToTargets

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:58'!
basicSvnGetHeadRevision: pathToTarget

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'pe 2/28/2008 11:35'!
basicSvnGetPropertiesFrom: aPath

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:19'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:16'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets

	self subclassResponsibility.! !

!SVNClient methodsFor: 'converting' stamp: 'rt 2/5/2008 11:32'!
normalizePath: aString 

	| modifiedPath returnPath |
	modifiedPath := aString collect: [:c | c = $\ ifTrue: [$/] ifFalse: [c]].
	(modifiedPath endsWith: '/')
		ifFalse: [returnPath := modifiedPath]
		ifTrue: 	[returnPath := modifiedPath copyFrom: 1 to: modifiedPath size - 1].
	((returnPath at: 4) = $/) ifFalse: [^returnPath].
	^(returnPath copyFrom: 1 to: 3), (returnPath copyFrom: 5 to: returnPath size).! !

!SVNClient methodsFor: 'accessing' stamp: 'pe 2/25/2008 11:54'!
svnAdd: aPath 

	^self basicSvnAdd: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'pe 2/25/2008 11:56'!
svnAddProperty: property WithValue:value To: target

	^self basicSvnAddProperty: property WithValue:value To: (self normalizePath: target)! !

!SVNClient methodsFor: 'accessing' stamp: 'test 2/27/2008 14:42'!
svnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self basicSvnCheckoutHeadRevisionFrom: (self normalizePath: repositoryURL) to: (self normalizePath: workingCopyPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 14:56'!
svnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath

	self basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: (self normalizePath: workingCopyPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/8/2008 00:56'!
svnCommit: aCollection 

	| commitArray |
	commitArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnCommit: commitArray! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 02:34'!
svnGetHeadRevision: aPath

	^ self basicSvnGetHeadRevision: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'pe 2/28/2008 11:56'!
svnGetPropertiesFrom: target

	| propertyArray popertyDict |
	propertyArray := (self basicSvnGetPropertiesFrom: (self normalizePath: target)).
	popertyDict := Dictionary new.
	1 to: propertyArray size by: 2 do: [:i |
		popertyDict
			at: (propertyArray at: i)
			put: (propertyArray at: i + 1)].
	^ popertyDict.! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 15:25'!
svnUpdateTargets: aCollection toRevisionByNumber: revisionNumber

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnUpdateTargets: updateArray toRevisionByNumber: revisionNumber! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 15:21'!
svnUpdateTargetsToHeadRevision: aCollection 

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnUpdateTargetsToHeadRevision: updateArray! !

SVNClient subclass: #SVNCommandLineClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/8/2008 01:08'!
basicSvnAdd: aPath 

	self executeViaOSProcessSynchronously: 'svn add ' , aPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'pe 2/26/2008 13:29'!
basicSvnAddProperty: key WithValue: value To: path

	| command |
	command := self buildCmdPropset: key value: value for: path.
	self executeViaOSProcessSynchronously: command.! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:35'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self executeViaOSProcessSynchronously: 'svn co ' , repositoryURL , ' ' , workingCopyPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:37'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	self executeViaOSProcessSynchronously: 'svn co -r ' , revisionNumber asString , ' ' , repositoryURL , ' ' , workingCopyPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/13/2008 02:32'!
basicSvnCommit: collectionOfTargets 

	| targets |
	targets := collectionOfTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn commit' , targets , ' -m "log"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:49'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn up -r', revisionNumber asString , targets! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:44'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn up' , targets! !

!SVNCommandLineClient methodsFor: 'build commands' stamp: 'pe 2/26/2008 13:27'!
buildCmdPropset: key value: value for: path 
	
	^ 'svn propset ' , key , ' ' , value , ' ' , path.! !

!SVNCommandLineClient methodsFor: 'OSProcess' stamp: 'rkrk 2/13/2008 02:33'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [p := ExternalOSProcess command: command.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 10) wait]].! !

!SVNCommandLineClient methodsFor: 'converting' stamp: 'rt 2/7/2008 10:56'!
normalizePath: aPath

	^'"' , (super normalizePath: aPath) , '"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 14:21'!
svnGetHeadRevision: aPath

	self flag: #TODO. "Dirty hack. Extract headrevision from
	the output of the command line somehow."
	^ SVNCApiClient new svnGetHeadRevision: aPath! !

Object subclass: #SVNDirectoryEntry
	instanceVariableNames: 'theName basePath properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

SVNDirectoryEntry subclass: #SVNDirectory
	instanceVariableNames: 'subdirectories files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNDirectory class methodsFor: 'instance creation' stamp: 'rkrk 2/25/2008 00:21'!
on: pathString
	
	FileDirectory
		splitName: pathString
		to: [:dirPath :localName |
			^ self named: localName basePath: dirPath].! !

!SVNDirectory methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:44'!
= other

	^ (super = other and:
		[self files = other files]) and:
			[self subdirectories = other subdirectories]! !

!SVNDirectory methodsFor: 'as yet unclassified' stamp: 'rt 2/29/2008 05:07'!
assureExistenceInParent
	"create a directory with the name 'theName' in 'self basePath' if it does not exists and add the directory to the working copy"

	| directory client |
	directory := FileDirectory on: self path.
	directory exists ifTrue: [^self].
	
	(directory directoryExists: self basePath) ifFalse: [^nil].
	
	directory createDirectory: self path.
	client := SVNCApiClient new.
	client svnAdd: self path.! !

!SVNDirectory methodsFor: 'svn functions' stamp: 'rkrk 2/25/2008 01:56'!
checkoutFrom: url

	| svnClient |
	svnClient := SVNCApiClient new.
	svnClient
		svnCheckoutHeadRevisionFrom: url asString
		to: self path.! !

!SVNDirectory methodsFor: 'svn functions' stamp: 'rkrk 2/25/2008 16:00'!
commit

	| pathsToCommit svnClient |
	pathsToCommit := self recursivelyGatherPathsOfAllElements.
	pathsToCommit addFirst: self path.
	self flag: #TODO. "Implement the primitives?"
	svnClient := SVNCApiClient new.
	"svn add the elements"
	pathsToCommit do: [:each | svnClient svnAdd: each].
	svnClient svnCommit: pathsToCommit asArray.
	
"	svnClient svnCommit:{'/Users/robertkrahn/studium/SWA/squeak/squeakSVN/images/soft/svnTests/workingCopy/TestProject'}."
	"svnClient svnAdd:  '/Users/robertkrahn/studium/SWA/squeak/squeakSVN/images/soft/svnTests/workingCopy/TestProject/SVNTestClassCreatedInAcceptanceTest/instance'"! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'rkrk 2/22/2008 13:49'!
createFileNamed: aString 

	| newFile |
	newFile := SVNFile
		named: aString
		basePath: self path.
	self files add: newFile.
	^ newFile! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'rkrk 2/23/2008 00:58'!
createFileNamed: filename withContent: content

	^ (self createFileNamed: filename)
		content: content;
		yourself! !

!SVNDirectory methodsFor: 'subdirectory manipulation' stamp: 'rkrk 2/22/2008 13:45'!
createSubDirectoryNamed: aString 
	
	| newDirectory |
	newDirectory := self class
		named: aString
		basePath: self path.
	self subdirectories add: newDirectory.
	^ newDirectory.! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:51'!
directoryExists: directoryName 

	^ self subdirectories anySatisfy: [:each |
		each theName = directoryName]! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:35'!
fileExists: fileName

	^ self files anySatisfy: [:each | fileName = each theName].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files
	^ files! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files: anObject
	files := anObject! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getFileNamed: fileName 
	
	^ self files
		detect: [:each | each theName = fileName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getSubDirectoryNamed: directoryName 
	
	^ self subdirectories
		detect: [:each | each theName = directoryName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'initialization' stamp: 'rkrk 2/21/2008 21:29'!
initialize

	super initialize.
	self
		files: Set new;
		subdirectories: Set new.! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rt 2/29/2008 01:25'!
pathsOfAllElements

	^ (((self files union: self subdirectories) collect: [:each | each path]) union: self propertyFilePathes) asOrderedCollection.! !

!SVNDirectory methodsFor: 'printing' stamp: 'rkrk 2/23/2008 22:05'!
printOn: aStream

	| printBlock |
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self theName;
		nextPutAll: ' - Subdirectories:'.
	printBlock := [:each |
		aStream
			nextPut: Character space;
			nextPutAll: each theName].
	self subdirectories do: printBlock.
	aStream nextPutAll: ' - Files:'.
	self files do: printBlock.
	aStream nextPut: $).! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:45'!
read
	
	(FileDirectory on: self path) exists
		ifFalse: [self error: 'There exists no directory with this name.'].
	super read.
	self readDirectoryEntries.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rt 2/29/2008 02:44'!
readDirectoriesInDir: dir

	| newSvnDirectory |
	dir directoryNames
		select: [:each | each ~= '.svn']
		thenDo: [:each |
			newSvnDirectory := SVNDirectory
				named: each
				basePath: self path.
				"self halt."
			newSvnDirectory read.
			self subdirectories add: newSvnDirectory].! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 2/21/2008 22:10'!
readDirectoryEntries

	| dir |
	dir := FileDirectory on: self path.
	self
		readFilesInDir: dir;
		readDirectoriesInDir: dir.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rt 2/29/2008 01:08'!
readFilesInDir: directory

	| newSvnFile |
	directory fileNames select: [:each | (each endsWith: '.properties') not]
		thenDo: [:each |
			newSvnFile := SVNFile
				named: each
				basePath: self path.
			newSvnFile read.
			self files add: newSvnFile].! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'test 2/25/2008 15:39'!
recursivelyGatherPathsOfAllElements

	| subElementsPaths |
	subElementsPaths := self subdirectories
			gather: [:each | each recursivelyGatherPathsOfAllElements].
	^ self pathsOfAllElements
		addAll: subElementsPaths;
		yourself.! !

!SVNDirectory methodsFor: 'storing' stamp: 'cop 2/27/2008 17:02'!
store
	(FileDirectory on: self path) assureExistence.
	super store.
	(self files union: self subdirectories) do: [:each |
		each store].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories
	^ subdirectories! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories: anObject
	subdirectories := anObject! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 20:41'!
named: aString basePath: pathName

	^ self new
		theName: aString;
		basePath: pathName
		yourself.! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:42'!
= other

	self species = other species ifFalse: [^ false].
	^ (self theName = other theName and:
		[self basePath = other basePath]) and:
			[self properties = other properties].! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rkrk 2/27/2008 02:25'!
addEntry

	| client |
	client := SVNCApiClient new.
	client svnAdd: self path! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath
	^ basePath! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath: anObject 
	basePath := anObject! !

!SVNDirectoryEntry methodsFor: 'testing' stamp: 'rkrk 2/21/2008 21:42'!
hash

	^ self theName hash! !

!SVNDirectoryEntry methodsFor: 'initialization' stamp: 'rkrk 2/21/2008 20:37'!
initialize

	super initialize.
	self properties: Dictionary new.! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 2/21/2008 20:33'!
path
	^ self basePath , FileDirectory slash , self theName! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties
	^ properties! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties: anObject
	properties := anObject! !

!SVNDirectoryEntry methodsFor: 'as yet unclassified' stamp: 'rt 2/29/2008 01:19'!
propertyFilePathes

	^self propertyFiles collect: [:each | self path, FileDirectory slash, each]! !

!SVNDirectoryEntry methodsFor: 'as yet unclassified' stamp: 'rt 2/29/2008 01:12'!
propertyFiles
| directory |
	directory := FileDirectory on: self path.
	^directory fileNames select: [:each | each endsWith: '.properties']! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:45'!
read
	
	self	readProperties.! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rt 2/29/2008 02:40'!
readProperties

	"| client |
	client := SVNCApiClient new.
	self properties: (client svnGetPropertiesFrom: self path)."
	
	| propertyFilePath content l |
	"select file"
	SVNDirectory new species = self species
		ifTrue: [propertyFilePath := self path, FileDirectory slash, '#.properties']
		ifFalse: [propertyFilePath := self path, '.properties'].
	(FileStream isAFileNamed: propertyFilePath) ifFalse: [^self].
	
	"read properties / cast"
	FileStream 
		readOnlyFileNamed: propertyFilePath
		do: [:stream | content := stream contents.].

	l := 1.
	[l < content lineCount] whileTrue: [
		self properties at: (content lineNumber: l) put: (content lineNumber: l + 1).
		l := l +2.]
	
	"close stream"! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'pe 2/26/2008 11:52'!
store
	self addEntry.
	self storeProperties! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rt 2/28/2008 23:59'!
storeProperties

	"| client |
	client := SVNCApiClient new.
	self properties keysAndValuesDo: [:key :value |
		client svnAddProperty: key WithValue: value To: self path]."
	| propertiesFilePath propertiesFile |
	self properties ifEmpty: [^self].
	
	"open stream"
	SVNDirectory new species = self species
		ifTrue: [propertiesFilePath := self path, FileDirectory slash , '#.properties']
		ifFalse: [propertiesFilePath := self path, '.properties'].
	propertiesFile := FileStream newFileNamed: propertiesFilePath.
	
	"fill stream"
	self properties keysAndValuesDo: [:key :value |
		propertiesFile
			nextPutAll: key;
			nextPut: Character cr;
			nextPutAll: value;
			nextPut: Character cr].

	"close stream and store in rep"
	propertiesFile close.
	(SVNCApiClient new) svnAdd: propertiesFilePath.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
theName

	^ theName! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
theName: aString 

	theName := aString.! !

SVNDirectoryEntry subclass: #SVNFile
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNFile class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 20:28'!
named: aString basePath: pathName content: content

	^ (self named: aString basePath: pathName)
		content: content;
		yourself.! !

!SVNFile methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:44'!
= other

	^ (super = other and:
		[self content = other content])! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content
	^ content! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content: anObject
	content := anObject! !

!SVNFile methodsFor: 'initialize-release' stamp: 'rkrk 2/21/2008 21:59'!
initialize

	super initialize.
	content := String new! !

!SVNFile methodsFor: 'printing' stamp: 'rkrk 2/23/2008 21:59'!
printOn: aStream

	super printOn: aStream.	
	aStream
		nextPut: $(;
		nextPutAll: self theName;
		nextPut: $).! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:45'!
read
	
	(FileStream isAFileNamed: self path)
		ifFalse: [self error: 'There exists no file with this name!!'].
	super read.
	self	readContent.! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 2/27/2008 02:26'!
readContent

	FileStream 
		readOnlyFileNamed: self path
		do: [:stream | content := stream contents.]! !

!SVNFile methodsFor: 'storing' stamp: 'pe 2/26/2008 11:51'!
store
	
	FileStream 
		forceNewFileNamed: self path
		do: [:stream | stream nextPutAll: content].
	super store.! !

Object subclass: #SVNDummy
	instanceVariableNames: 'i1 i2'
	classVariableNames: 'C1 C2'
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy commentStamp: '<historical>' prior: 0!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy class methodsFor: 'dummy' stamp: 'cop 2/7/2008 19:50'!
m3

	^ 3! !

!SVNDummy class methodsFor: 'convenience' stamp: 'cop 2/7/2008 19:50'!
sourceCodeForM2
	^ 'm2
	^ 2'! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/23/2008 11:54'!
m1
	^ 1! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/24/2008 23:09'!
m2
	^ 2! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'cop 2/7/2008 19:50'!
methodWithSpecialCharacter: aString
	^ aString! !

Object subclass: #SVNDummy99
	instanceVariableNames: 'a'
	classVariableNames: 'A'
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNDummy99 class
	instanceVariableNames: 'b'!

SVNDummy99 class
	instanceVariableNames: 'b'!

!SVNDummy99 methodsFor: 'as yet unclassified' stamp: 'mu 2/28/2008 11:50'!
* anObject! !

!SVNDummy99 methodsFor: 'as yet unclassified' stamp: 'mu 2/28/2008 11:50'!
/ anObject! !

!SVNDummy99 methodsFor: 'as yet unclassified' stamp: 'mu 2/28/2008 11:50'!
< anObject! !

!SVNDummy99 methodsFor: 'as yet unclassified' stamp: 'mu 2/28/2008 11:50'!
> anObject! !

!SVNDummy99 methodsFor: 'as yet unclassified' stamp: 'mu 2/28/2008 11:50'!
\ anObject! !

!SVNDummy99 methodsFor: 'as yet unclassified' stamp: 'mu 2/28/2008 11:51'!
testMethod: anObject! !

!SVNDummy99 methodsFor: 'as yet unclassified' stamp: 'mu 2/28/2008 11:51'!
| anObject! !

Object subclass: #SVNElement
	instanceVariableNames: 'theName parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNElement subclass: #SVNClass
	instanceVariableNames: 'theClass superclassName classVariables instanceVariables classInstanceVariables comment category methods classMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNClass commentStamp: 'mu 2/7/2008 16:29' prior: 0!
A SVNClass is blablabla.

Instance Variables
	class:		<Object>

class
	- xxxxx
!

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 2/23/2008 19:44'!
forExistingClass: aClass

	^ (self new)
		forExistingClass: aClass;
		yourself! !

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 2/23/2008 21:47'!
forSerializedClassIn: aSVNDirectory 
	
	^ self new
		forSerializedClassIn: aSVNDirectory;
		yourself.! !

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 2/25/2008 01:40'!
name: className superclassName: superClassName instanceVariables: instVars classVariables: classVars classInstanceVariables: classInstVars comment: comment category: classCategory

	^ self new
		theName: className;
		superclassName: superClassName;
		instanceVariables: instVars;
		classVariables: classVars;
		classInstanceVariables: classInstVars;
		comment:  comment;
		category: classCategory;
		yourself.! !

!SVNClass methodsFor: 'comparing' stamp: 'test 2/25/2008 02:18'!
= other

	super = other ifFalse: [^ false].
	(self superclassName = other superclassName and:
		[self instanceVariables = other instanceVariables] and:
		[self classVariables = other classVariables] and:
		[self classInstanceVariables = other classInstanceVariables] and:
		[self comment = other comment]) ifFalse: [^ false].
	^  self category = other category and:
		[self methods = other methods] and:
		[self classMethods = other classMethods]! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category
	^ category! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category: anObject
	category := anObject! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables
	^ classInstanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables: anObject
	classInstanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classInstanceVariablesString

	^ self stringFromCollection: self classInstanceVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/25/2008 02:15'!
classMethods

	self flag: #TODO. "Methods now if they are class or instance methods.
	Why distinguish in SVNClass?"
	^ classMethods asSet! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/25/2008 02:16'!
classMethods: anObject

	self flag: #TODO. "Methods now if they are class or instance methods.
	Why distinguish in SVNClass?"
	classMethods := anObject asSet! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables
	^ classVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables: anObject
	classVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classVariablesString

	^ self stringFromCollection: self classVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment
	^ comment! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment: anObject
	comment := anObject! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/25/2008 01:48'!
contentsForFile

	self flag: #TODO. "Mapping method to contents of a file"
	self flag: #TODO. "Switch to streams entirely?"
	^ String streamContents: [:stream |
		stream
			nextPutAll: 'Instance side';
			nextPut: Character cr;
			nextPutAll: self superclassName;
			nextPut: Character cr;
			nextPutAll: self category;
			nextPut: Character cr;
			nextPutAll: self instanceVariablesString;
			nextPut: Character cr;
			nextPutAll: self classVariablesString;
			nextPut: Character cr;
			nextPutAll: ''"(self createStringFromCollection: self theClass poolDictionaryNames)";
			nextPut: Character cr;
			nextPutAll: 'Class side';
			nextPut: Character cr;
			nextPutAll: self classInstanceVariablesString].! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 2/23/2008 22:54'!
createClass: aClass withContents: contents

	| superclass |
	self flag: #TODO.
	superclass := Smalltalk classNamed: self superclassName.
	self assert: superclass notNil.
	self theClass: (superclass
				subclass: self theName
				instanceVariableNames: self instanceVariables
				classVariableNames: self classVariables
				poolDictionaries: '' "No test!!!!!!"
				category: self category).
	self theClass classSide instanceVariableNames: self classInstanceVariables.
	^ self theClass.! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/21/2008 16:40'!
createStringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 2/29/2008 02:15'!
extractCategoryFrom: aSVNDirectory
	
	^ aSVNDirectory properties at: self nameForCategoryProperty.! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 2/29/2008 02:15'!
extractClassVarsFrom: aSVNDirectory
	
	^ (aSVNDirectory properties at: self nameForClassVariablesProperty) substrings asSet! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 2/29/2008 02:15'!
extractInstVarsFrom: aSVNDirectory
	
	^ (aSVNDirectory properties at: self nameForInstanceVariablesProperty) substrings.! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 2/29/2008 02:14'!
extractMetaInstVarsFrom: aSVNDirectory
	
	^ (aSVNDirectory properties at: self nameForClassInstanceVariablesProperty) substrings! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 14:53'!
extractPoolDictFrom: contents
	
	^ contents lineNumber: 6! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 2/29/2008 02:07'!
extractSuperclassFrom: aSVNDirectory
	
	^ (aSVNDirectory properties at: self nameForSuperclassProperty) asSymbol! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 2/24/2008 13:17'!
forExistingClass: aClass

	self theName: aClass name.
	self superclassName: aClass superclass name.
	self instanceVariables: aClass instVarNames.
	self classVariables: aClass classVarNames.
	self classInstanceVariables: aClass class instVarNames.
	self comment: aClass comment.
	self category: aClass category.
	
	self methods: (aClass methodDict collect: [:each |
		SVNMethod forExistingMethod: each]).
	self classMethods: (aClass class methodDict collect: [:each |
		SVNMethod forExistingMethod: each]).
	
	self theClass: aClass.! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 2/23/2008 21:52'!
forSerializedClassIn: svnDirectory 
	
	self restoreFrom: svnDirectory.! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 2/24/2008 13:29'!
hash

	^ self theName hash! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 2/25/2008 01:45'!
initialize

	super initialize.
	self
		methods: {};
		classMethods: {}.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables
	^ instanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables: anObject
	instanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 23:59'!
instanceVariablesString

	^ self stringFromCollection: self instanceVariables.! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rt 2/29/2008 04:05'!
load
	
	| superclass |
	self flag: #TODO.
	superclass := Smalltalk classNamed: self superclassName.
	self assert: superclass notNil.
	self theClass: (superclass
				subclass: self theName asSymbol
				instanceVariableNames: self instanceVariablesString
				classVariableNames: self classVariablesString
				poolDictionaries: '' "No test!!!!!!"
				category: self category).
	self theClass classSide instanceVariableNames: self classInstanceVariablesString.
	
	self methods do: [:each | each load].
	self classMethods do: [:each | each load].! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/25/2008 02:15'!
methods
	
	self flag: #TODO. "Methods now if they are class or instance methods.
	Why distinguish in SVNClass?"
	^ methods asSet! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/25/2008 02:16'!
methods: anObject

	self flag: #TODO. "Methods now if they are class or instance methods.
	Why distinguish in SVNClass?"
	methods := anObject asSet! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rt 2/29/2008 02:03'!
nameForCategoryProperty
	^'category'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 2/23/2008 22:20'!
nameForClassDetailsFile
	^ 'properties'! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rt 2/29/2008 02:16'!
nameForClassInstanceVariablesProperty
	^ 'classInstanceVariables'! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rt 2/29/2008 02:17'!
nameForClassVariablesProperty
	^ 'classVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 2/23/2008 12:03'!
nameForCommentFile

	^ 'comment'! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rt 2/29/2008 02:17'!
nameForInstanceVariablesProperty
	^ 'instanceVariables'! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rt 2/29/2008 02:05'!
nameForSuperclassProperty
	^'superclass'! !

!SVNClass methodsFor: 'printing' stamp: 'rkrk 2/23/2008 23:52'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theName printOn: aStream.
	aStream nextPut: $).! !

!SVNClass methodsFor: 'restoring' stamp: 'rkrk 2/24/2008 13:45'!
restoreClassMethodsFrom: aSVNDirectory 
	
	self flag: #TODO. "Methods now if they are class or instance methods.
	Why distinguish in SVNClass?"
	self classMethods: (aSVNDirectory files collect: [:each |
		SVNMethod restoreFrom: each]).! !

!SVNClass methodsFor: 'restoring' stamp: 'rt 2/29/2008 01:59'!
restoreFrom: aSVNDirectory 
	| classDetails classMethodDirectory instanceMethodDirectory |
	self flag: #TODO.
	classDetails := aSVNDirectory getFileNamed: self nameForClassDetailsFile.
	self
		theName: aSVNDirectory theName ;
		superclassName: (self extractSuperclassFrom: aSVNDirectory) ;
		instanceVariables: (self extractInstVarsFrom: aSVNDirectory) ;
		classVariables: (self extractClassVarsFrom: aSVNDirectory) ;
		classInstanceVariables: (self extractMetaInstVarsFrom: aSVNDirectory) ;
		"poolDictionaries: (self extractPoolDictFrom: classDetails)"	"Not test!!!!!!"
		category: (self extractCategoryFrom: aSVNDirectory);
		comment: (aSVNDirectory getFileNamed: self nameForCommentFile) content.
	"Use accessor for 'instance' and 'class'"
	classMethodDirectory := aSVNDirectory getSubDirectoryNamed: 'class'.
	"Methods now if they are class or instance methods. Why distinguish in SVNClass?"
	self restoreClassMethodsFrom: classMethodDirectory.
	instanceMethodDirectory := aSVNDirectory getSubDirectoryNamed: 'instance'.
	"Methods now if they are class or instance methods. Why distinguish in SVNClass?"
	self restoreInstanceMethodsFrom: instanceMethodDirectory.! !

!SVNClass methodsFor: 'restoring' stamp: 'rkrk 2/24/2008 13:45'!
restoreInstanceMethodsFrom: aSVNDirectory 
	
	self flag: #TODO. "Methods now if they are class or instance methods.
	Why distinguish in SVNClass?"
	self methods: (aSVNDirectory files collect: [:each |
		SVNMethod restoreFrom: each]).! !

!SVNClass methodsFor: 'storing' stamp: 'rt 2/29/2008 02:16'!
storeClassDetailsIn: svnDirectory 

	| properties |
	properties := Dictionary new.
	properties at: self nameForSuperclassProperty put: self superclassName.
	properties at: self nameForCategoryProperty put: self category.
	properties at: self nameForInstanceVariablesProperty put: self instanceVariablesString.
	properties at: self nameForClassVariablesProperty put: self classVariablesString.
	properties at: self nameForClassInstanceVariablesProperty put: self classInstanceVariablesString.
	
	svnDirectory properties: properties.! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 2/24/2008 13:09'!
storeClassMethodsIn: svnDirectory

	| classSideDirectory |
	self flag: #TODO.	"Redundant to storing of instance methods???"
	classSideDirectory := svnDirectory createSubDirectoryNamed: 'class'.
	self classMethods do: [:each | each storeIn: classSideDirectory.]! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 2/25/2008 01:45'!
storeCommentIn: svnDirectory 

	svnDirectory
		createFileNamed: self nameForCommentFile
		withContent: self comment.! !

!SVNClass methodsFor: 'storing' stamp: 'cop 2/27/2008 15:55'!
storeIn: svnDirectory

	| classDirectory |
	"self assert: self theClass notNil."
	classDirectory := svnDirectory createSubDirectoryNamed: self theName.
	self
		storeClassMethodsIn: classDirectory ;
		storeInstanceMethodsIn: classDirectory ;
		storeCommentIn: classDirectory ;
		storeClassDetailsIn: classDirectory.	"Change the name"
	"TODO: pass projectDirectory to all my elements"
	"classDirectory store."! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 2/24/2008 13:09'!
storeInstanceMethodsIn: svnDirectory

	| instanceSideDirectory |
	self flag: #TODO.	"Redundant to storing of class methods???"
	instanceSideDirectory := svnDirectory createSubDirectoryNamed: 'instance'.
	self methods do: [:each | each storeIn: instanceSideDirectory].! !

!SVNClass methodsFor: 'convenience' stamp: 'rkrk 2/23/2008 23:59'!
stringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName
	^ superclassName! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName: anObject
	superclassName := anObject! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 01:18'!
theClass
	^ theClass! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 01:18'!
theClass: aClass 
	theClass := aClass! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:40'!
writeClassMethodsTo: aPath 

	| path |
	path := aPath , 'class' , FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self
		writeMethods: self theClass classSide methodDictionary
		to: path.! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:05'!
writeCommentTo: aPath 
	
	self
		write: self theClass comment
		to: aPath , FileDirectory slash , 'comment'! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:41'!
writeElementTo: aPath

	| path |
	path := aPath , FileDirectory slash , self theClass name , FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self
		writeClassMethodsTo: path;
		writeInstanceMethodsTo: path;
		writeCommentTo: path;
		writePropertiesTo: path! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:41'!
writeInstanceMethodsTo: aPath

	| path |
	path := aPath , 'instance' , FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self
		writeMethods: self theClass methodDictionary
		to: path! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/24/2008 12:38'!
writeMethods: aMethDict to: aPath
	
	aMethDict do: [ :each | (SVNMethod forExistingMethod: each) writeElementTo: aPath].! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 01:41'!
writePropertiesTo: aPath

	self flag: #TODO "Hard coded string".
	self write: self contentsForFile to: aPath, FileDirectory slash, 'properties'! !

!SVNElement class methodsFor: 'instance creation' stamp: 'test 2/12/2008 13:34'!
readElementFrom: aPath
	^ (self new)
		readElementFrom: aPath;
		yourself! !

!SVNElement class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 12:50'!
readElementFrom: aPath for: aClass

	self flag: #TODO. "Necessary????"
	^ (self new)
		readElementFrom: aPath for: aClass;
		yourself! !

!SVNElement methodsFor: 'as yet unclassified' stamp: 'rkrk 2/24/2008 13:34'!
= other

	self species = other species ifFalse: [^ false].
		^ self theName = other theName.! !

!SVNElement methodsFor: 'svn commands' stamp: 'cop 2/27/2008 16:30'!
commit
	^self subclassResponsibility! !

!SVNElement methodsFor: 'read' stamp: 'mu 2/7/2008 13:54'!
contentsOfFileNamed: pathToFile

	^ (FileStream readOnlyFileNamed: pathToFile) contents.! !

!SVNElement methodsFor: 'svn commands' stamp: 'cop 2/27/2008 16:30'!
delete
	^self subclassResponsibility! !

!SVNElement methodsFor: 'accessing' stamp: 'cop 2/28/2008 12:26'!
parent
	^parent! !

!SVNElement methodsFor: 'accessing' stamp: 'cop 2/28/2008 12:26'!
parent: aSVNElement
	parent := aSVNElement! !

!SVNElement methodsFor: 'write' stamp: 'cop 2/12/2008 11:50'!
readElementFrom: aPath for: anObject 
	self subclassResponsibility! !

!SVNElement methodsFor: 'svn commands' stamp: 'cop 2/27/2008 16:30'!
revert
	^self subclassResponsibility! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:31'!
theName
	^ theName! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:31'!
theName: anObject
	theName := anObject! !

!SVNElement methodsFor: 'svn commands' stamp: 'cop 2/27/2008 16:30'!
update
	^self subclassResponsibility! !

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/8/2008 01:22'!
write: aString to: aPath

	(FileStream forceNewFileNamed: aPath )
		nextPutAll: aString;
		close.! !

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/8/2008 01:22'!
writeElementTo: aPath

	self subclassResponsibility.! !

SVNElement subclass: #SVNMethod
	instanceVariableNames: 'nameOfClass category source timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 2/24/2008 01:29'!
forExistingMethod: aCompiledMethod 
	
	^ self new
		forExistingMethod: aCompiledMethod;
		yourself! !

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 2/24/2008 01:15'!
restoreFrom: aSVNFile 
	
	^ self new
		restoreFrom: aSVNFile;
		yourself.! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 2/24/2008 01:39'!
= otherMethod

	self species = otherMethod species ifFalse: [^ false].
	^ self methodSelector = otherMethod methodSelector and: 
		[self category = otherMethod category] and:
			[self source = otherMethod source] and:
				[self nameOfClass = otherMethod nameOfClass] and:
					[self timeStamp = otherMethod timeStamp]! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
category
	^ category! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
category: anObject
	category := anObject! !

!SVNMethod methodsFor: 'serializing' stamp: 'rkrk 2/24/2008 01:50'!
contentsForFile
	
	"Mapping method to contents of a file"
	self flag: #TODO.
	
	"For now: save the name of the category in the first line. The source code below."
	^ self nameOfClass , String cr , self category , String cr , self timeStamp , String cr , self source! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'cop 2/28/2008 13:28'!
convertFilenameToSelector: fileName

	^ fileName 
		replaceAll: ${ 
			with: $<;
		replaceAll: $} 
			with: $>;
		replaceAll: $( 
			with:$/;
		replaceAll: $) 
			with: $\;
		replaceAll: $'
			with: $*;
		replaceAll: $$
			with: $|;
		replaceAll: $# 
			with: $:.! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:00'!
extractCategoryFrom: svnFile

	^ svnFile properties at: self nameForCategoryProperty! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:01'!
extractClassFrom: svnFile

	^ svnFile properties at: self nameForClassProperty! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 01:58'!
extractSourceCodeFrom: svnFile

	^ svnFile content! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:01'!
extractTimeStampFrom: svnFile

	^ svnFile properties at: self nameForTimeStampProperty! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'cop 2/28/2008 12:57'!
fileName
	^ self methodSelector asString
		replaceAll: $<
			with: ${ ;
		replaceAll: $>
			with: $} ;
		replaceAll: $/
			with: $( ;
		replaceAll: $\
			with: $) ;
		replaceAll: $*
			with: $' ;
		replaceAll: $|
			with: $$ ;
		replaceAll: $:
			with: $#! !

!SVNMethod methodsFor: 'initialize' stamp: 'rkrk 2/24/2008 01:53'!
forExistingMethod: aCompiledMethod

	| methodReference |
	methodReference := aCompiledMethod methodReference.
	self
		methodSelector: methodReference methodSymbol;
		nameOfClass: methodReference actualClass name;
		category: methodReference category;
		source: methodReference source;
		timeStamp: methodReference timeStamp.! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 2/24/2008 12:36'!
hash

	^ self methodSelector hash! !

!SVNMethod methodsFor: 'modifying the system' stamp: 'rt 2/29/2008 04:35'!
load
	
	| class classAndSideArray readedClass |

	"prepare the 'class name'"
	classAndSideArray := self nameOfClass substrings.
	self assert: classAndSideArray size < 3.
	
	"find the correct class"
	readedClass := Smalltalk at: (classAndSideArray at: 1) asSymbol.
	classAndSideArray size = 2
		ifTrue: [ (classAndSideArray at: 2) = 'class'
			ifTrue: [class := readedClass class] ]
		ifFalse: [class := readedClass].
		
	class
		compile: self source
		classified: self category
		withStamp: self timeStamp
		notifying: nil.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:28'!
methodSelector

	^ self theName! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:28'!
methodSelector: aString

	self theName: aString! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:00'!
nameForCategoryProperty
	^ 'category'! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:01'!
nameForClassProperty
	^ 'class'! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:01'!
nameForTimeStampProperty
	^ 'timestamp'! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:27'!
nameOfClass
	^ nameOfClass! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:27'!
nameOfClass: anObject
	nameOfClass := anObject! !

!SVNMethod methodsFor: 'printing' stamp: 'rkrk 2/24/2008 02:29'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self nameOfClass;
		nextPutAll: '>>';
		nextPutAll: self methodSelector;
		nextPut: $).! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/23/2008 16:53'!
readElementFrom: aPath for: aClass

	| contents sourceCode category |
	contents := self contentsOfFileNamed: aPath.
	category := self extractCategoryFrom: contents.
	sourceCode := self extractSourceCodeFrom: contents.
	self methodReference: (aClass >> (aClass compile: sourceCode
		   classified: category
		   withStamp: (self extractTimeStampFrom: contents)
		   notifying: (SyntaxError new category: category) ))
		   methodReference.! !

!SVNMethod methodsFor: 'restoring' stamp: 'rkrk 2/25/2008 02:20'!
restoreFrom: aSVNFile 

	self
		methodSelector: (self convertFilenameToSelector: aSVNFile theName asString);
		category: (self extractCategoryFrom: aSVNFile);
		source: (self extractSourceCodeFrom: aSVNFile);
		nameOfClass: (self extractClassFrom: aSVNFile);
		timeStamp: (self extractTimeStampFrom: aSVNFile).
	"self methodReference: (aClass >> (aClass compile: sourceCode
		   classified: category
		   withStamp: (self extractTimeStampFrom: contents)
		   notifying: (SyntaxError new category: category) ))
		   methodReference."! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
source
	^ source! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
source: anObject
	source := anObject! !

!SVNMethod methodsFor: 'storing' stamp: 'rkrk 2/24/2008 02:03'!
storeIn: aSVNDirectory 
	
	| svnFile |
	svnFile := aSVNDirectory
		createFileNamed: self fileName
		withContent: self source.
	svnFile properties
		at: self nameForClassProperty
		put: self nameOfClass.
	svnFile properties
		at: self nameForCategoryProperty 
		put: self category.
	svnFile properties
		at: self nameForTimeStampProperty 
		put: self timeStamp.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
timeStamp
	^ timeStamp! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
timeStamp: anObject
	timeStamp := anObject! !

SVNElement subclass: #SVNProject
	instanceVariableNames: 'versionedClasses versionedMethods workingCopyDirectory repositoryURL projectDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNProject class methodsFor: 'instance creation' stamp: 'pe 2/28/2008 12:18'!
checkoutProject: aName fromURL: url inWorkingCopy: aSVNDirectory 
	
	^ self new
		repositoryURL: url;
		theName: aName;
		workingCopyDirectory: aSVNDirectory;
		checkout;
		yourself.! !

!SVNProject class methodsFor: 'instance creation' stamp: 'test 2/28/2008 11:20'!
named: aString 
	^self new
		theName: aString;
		setDefaultWorkingCopyDirectory;
		yourself.! !

!SVNProject class methodsFor: 'instance creation' stamp: 'rkrk 2/25/2008 02:08'!
restoreFrom: aSVNDirectory 
	
	^ self new
		restoreFrom: aSVNDirectory;
		yourself.! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 2/25/2008 01:35'!
addClass: aClass

	^ self addSVNClass: (SVNClass forExistingClass: aClass)! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 2/24/2008 12:36'!
addMethod: aMethod 
	
	^ self versionedMethods add: (SVNMethod forExistingMethod: aMethod)! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 2/25/2008 01:34'!
addSVNClass: svnClass

	^ self versionedClasses add: svnClass! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 01:16'!
allVersionedMethods
	
	^ self versionedClasses
		inject: self versionedMethods
		into: [:allMethods :class | allMethods addAll: class methods].! !

!SVNProject methodsFor: 'svn functions' stamp: 'rt 2/29/2008 04:54'!
checkout

	self workingCopyDirectory checkoutFrom: self repositoryURL.
	self projectDirectory assureExistenceInParent.
	self projectDirectory read.
	self restoreFrom: self projectDirectory.! !

!SVNProject methodsFor: 'svn functions' stamp: 'cop 2/27/2008 17:43'!
commit
	self storeIn: self workingCopyDirectory.
	self workingCopyDirectory commit.! !

!SVNProject methodsFor: 'as yet unclassified' stamp: 'cop 2/27/2008 16:21'!
getCachePath
	| path |
	path := SmalltalkImage current imagePath asString, FileDirectory slash, 'workingCopy-cache'.
	(FileDirectory on: path) assureExistence.
	^path! !

!SVNProject methodsFor: 'adding' stamp: 'cop 2/27/2008 17:27'!
initialize

	super initialize.
	versionedClasses := Set new.
	versionedMethods := Set new.! !

!SVNProject methodsFor: 'installing' stamp: 'rkrk 2/25/2008 02:25'!
load
	
	self flag: #TODO. "Quick hack for now"
	self versionedClasses do: [:each | each load].! !

!SVNProject methodsFor: 'accessing' stamp: 'pe 2/28/2008 12:02'!
projectDirectory
	^ projectDirectory! !

!SVNProject methodsFor: 'accessing' stamp: 'pe 2/28/2008 12:03'!
projectDirectory: aSVNDirectory
	projectDirectory := aSVNDirectory! !

!SVNProject methodsFor: 'svn functions' stamp: 'cop 2/27/2008 16:51'!
removeSVNClass: aSVNClass
	^ self versionedClasses remove: aSVNClass! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/25/2008 01:53'!
repositoryURL
	
	^ repositoryURL! !

!SVNProject methodsFor: 'accessing' stamp: 'test 2/28/2008 11:19'!
repositoryURL: anURL 
	
	repositoryURL := anURL.! !

!SVNProject methodsFor: 'restoring' stamp: 'rkrk 2/25/2008 02:06'!
restoreFrom: aSVNDirectory 
	
	self flag: #TODO. "Piece of mapping is here"
	self theName: aSVNDirectory theName.
	aSVNDirectory subdirectories do: [:each |
		self addSVNClass: (SVNClass forSerializedClassIn: each)].! !

!SVNProject methodsFor: 'as yet unclassified' stamp: 'cop 2/27/2008 17:35'!
setDefaultWorkingCopyDirectory
	self workingCopyDirectory: (SVNDirectory on: (self getCachePath, FileDirectory slash,
								(SecureHashAlgorithm new hashMessage: self repositoryURL asString) asString ) )! !

!SVNProject methodsFor: 'serialization' stamp: 'rkrk 2/25/2008 00:26'!
store

	self storeIn: self workingCopyDirectory.! !

!SVNProject methodsFor: 'serialization' stamp: 'rkrk 2/25/2008 02:07'!
storeIn: svnDirectory 

	| projectDirectory |
	projectDirectory := svnDirectory createSubDirectoryNamed: self theName.
	(self versionedClasses union: self versionedMethods) do: [:each |
		each storeIn: projectDirectory].
	"TODO: pass projectDirectory to all my elements"
	projectDirectory store! !

!SVNProject methodsFor: 'installing' stamp: 'rkrk 2/25/2008 01:48'!
unload
	self flag: #TODO.! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:31'!
versionedClasses
	
	^ versionedClasses ! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/2/2008 19:25'!
versionedMethods
	
	^ versionedMethods! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/25/2008 00:26'!
workingCopyDirectory
	^ workingCopyDirectory! !

!SVNProject methodsFor: 'accessing' stamp: 'pe 2/28/2008 12:46'!
workingCopyDirectory: anObject
	workingCopyDirectory := anObject.
	self assert: self theName notNil.
	self projectDirectory: (SVNDirectory on: workingCopyDirectory path, FileDirectory slash, self theName).! !

Object subclass: #SVNNode
	instanceVariableNames: 'element parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

SVNNode subclass: #SVNClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 16:47'!
getChildren
	^ OrderedCollection 
		with: ((SVNInstanceSideOfClassNode element: self element parent: self) 
												myDependents: (Array with: self);
												yourself )
		with: ((SVNClassSideOfClassNode element: self element parent: self) 
												myDependents: (Array with: self);
												yourself )
		with: ((SVNCommentNode element: self element parent: self) 
												myDependents: (Array with: self);
												yourself )! !

SVNNode subclass: #SVNClassSideOfClassNode
	instanceVariableNames: 'selector label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNClassSideOfClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 16:47'!
getChildren
	^element classMethods collect: [ :each | (SVNMethodNode element: each parent: self)
												myDependents: (Array with: self);
												yourself  ]! !

!SVNClassSideOfClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 10:51'!
getLabel
	^'class'! !

SVNNode subclass: #SVNCommentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNCommentNode methodsFor: 'svn functions' stamp: 'cop 2/27/2008 16:57'!
delete
	element comment: String new! !

!SVNCommentNode methodsFor: 'menu' stamp: 'cop 2/27/2008 17:00'!
deleteMenuLabel
	^'Clear comment'! !

!SVNCommentNode methodsFor: 'functionality' stamp: 'cop 2/26/2008 12:06'!
getLabel
	^'comment'! !

SVNNode subclass: #SVNInstanceSideOfClassNode
	instanceVariableNames: 'selector label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNInstanceSideOfClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 16:47'!
getChildren
	^element methods collect: [ :each | (SVNMethodNode element: each parent: self)
										myDependents: (Array with: self);
										yourself  ]! !

!SVNInstanceSideOfClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 10:52'!
getLabel
	^'instance'! !

SVNNode subclass: #SVNMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNNode class methodsFor: 'as yet unclassified' stamp: 'cop 2/27/2008 16:46'!
element: aSVNElement
	^(self new)
		element: aSVNElement;
		yourself.! !

!SVNNode class methodsFor: 'as yet unclassified' stamp: 'cop 2/27/2008 13:17'!
element: aSVNElement parent: aSVNNode
	^(self new)
		element: aSVNElement;
		parent: aSVNNode;
		yourself.! !

!SVNNode methodsFor: 'svn functions' stamp: 'cop 2/27/2008 16:29'!
commit
	element commit! !

!SVNNode methodsFor: 'svn functions' stamp: 'cop 2/27/2008 16:45'!
delete
	self changed: #deleteMe with: self! !

!SVNNode methodsFor: 'menu' stamp: 'cop 2/27/2008 16:59'!
deleteMenuLabel
	^'Delete'! !

!SVNNode methodsFor: 'accessing' stamp: 'cop 2/26/2008 11:33'!
element
	^element! !

!SVNNode methodsFor: 'accessing' stamp: 'cop 2/26/2008 11:33'!
element: aSVNElement
	element := aSVNElement! !

!SVNNode methodsFor: 'functionality' stamp: 'cop 2/26/2008 12:14'!
getChildren
	^OrderedCollection new! !

!SVNNode methodsFor: 'functionality' stamp: 'cop 2/26/2008 11:54'!
getLabel
	^element theName! !

!SVNNode methodsFor: 'menu' stamp: 'cop 2/27/2008 16:59'!
getMenuOn: aMenu
	aMenu add: 'Update' target: self action: #update.
	aMenu add: 'Commit' target: self action: #commit.
	aMenu addLine.
	aMenu add: 'Revert' target: self action: #revert.
	aMenu add: self deleteMenuLabel target: self action: #delete.
	^aMenu! !

!SVNNode methodsFor: 'accessing' stamp: 'cop 2/27/2008 13:16'!
parent
	^parent! !

!SVNNode methodsFor: 'accessing' stamp: 'cop 2/27/2008 13:16'!
parent: aSVNNode
	parent := aSVNNode! !

!SVNNode methodsFor: 'message handling' stamp: 'cop 2/26/2008 12:49'!
perform: selector orSendTo: otherTarget
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SVNNode methodsFor: 'svn functions' stamp: 'cop 2/27/2008 16:31'!
revert
	element revert! !

!SVNNode methodsFor: 'svn functions' stamp: 'cop 2/27/2008 16:29'!
update
	element update! !

SVNNode subclass: #SVNProjectNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNProjectNode methodsFor: 'svn functions' stamp: 'cop 2/28/2008 12:45'!
addClass
	SVNAddClassDialog open myDependents: (Array with: self )! !

!SVNProjectNode methodsFor: 'svn functions' stamp: 'cop 2/27/2008 15:01'!
checkout
	element checkout.
	element load.! !

!SVNProjectNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 16:47'!
getChildren
	^ element versionedClasses collect: [ :each | (SVNClassNode element: each parent: self)
												myDependents: (Array with: self). ]! !

!SVNProjectNode methodsFor: 'menu' stamp: 'cop 2/28/2008 12:45'!
getMenuOn: aMenu
	super getMenuOn: aMenu.
	aMenu addLine.
	aMenu add: 'Set working dir' target: self action: #setWC.
	aMenu add: 'Set URL' target: self action: #setURL.
	aMenu add: 'Checkout' target: self action: #checkout.
	aMenu add: 'Add class' target: self action: #addClass.
	^aMenu! !

!SVNProjectNode methodsFor: 'ui' stamp: 'cop 2/27/2008 11:34'!
setURL
	(SVNSetURLDialog openWith: element repositoryURL) myDependents: (Array with: self)! !

!SVNProjectNode methodsFor: 'ui' stamp: 'cop 2/28/2008 11:07'!
setWC
	(SVNSetWCPathDialog openWith: element workingCopyDirectory path ) myDependents: (Array with: self)! !

!SVNProjectNode methodsFor: 'updating' stamp: 'cop 2/28/2008 13:24'!
update: aSelector with: anObject
	aSelector == 	#editedURL ifTrue: [element repositoryURL: (Url absoluteFromText: anObject asString ).
									^self ].
	aSelector == 	#editedWCPath ifTrue: [element workingCopyDirectory: (SVNDirectory on: anObject asString ).
									^self ].
	aSelector == 	#addClass ifTrue: [ (element addClass: (SystemDictionary new classNamed: anObject asString ))
									storeIn: element workingCopyDirectory.
									element store.
									self changed: #updateTree.
									^self ].		
	aSelector == 	#deleteMe ifTrue: [ (element removeSVNClass: anObject)
									storeIn: element workingCopyDirectory.
									element store.
									self changed: #updateTree.
									^self ].		
	super update: aSelector with: anObject.! !

Object subclass: #SqueakSVNPluginCaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SqueakSVNPluginCaller commentStamp: 'rkrk 1/7/2008 02:27' prior: 0!
Only for testing purposes!!!

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/31/2008 05:20'!
answer17

	<primitive: 'answerSeventeen' module: 'PluginAnswering17'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/4/2008 16:58'!
callStringTest01

	<primitive: 'stringTest01' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:27'!
primSvnGetHeadRevision: target

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:29'!
primSvnModifiedAdd: target

	<primitive: 'svnModifiedAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

TestCase subclass: #SVNTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNTestCase subclass: #SVNClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNClassTest methodsFor: 'assertion' stamp: 'rkrk 2/24/2008 13:53'!
assertSVNClass: aSVNClass hasStateFromSystemClass: aClass 
	
	
	| instanceMethodSelectors expectedMethodSelectors classMethodSelectors expectedclassMethodSelectors |
	self assert: aSVNClass theName = aClass name.
	self assert: aSVNClass superclassName = aClass superclass name.
	self assert: aSVNClass instanceVariables = aClass instVarNames.
	self assert: aSVNClass classVariables = aClass classVarNames.
	self assert: aSVNClass classInstanceVariables = aClass class instVarNames.
	self assert: aSVNClass comment = aClass comment.
	self assert: aSVNClass category = aClass category.
	
	self flag: #TODO. "Implementation details about the file mapping
	are spread here"
	instanceMethodSelectors := aSVNClass methods collect: [:each |
		each fileName].
	expectedMethodSelectors := aClass methodDict collect: [:each |
		each selector asString replaceAll: $: with: $#].
	self assert: instanceMethodSelectors asSet = expectedMethodSelectors asSet.
	classMethodSelectors := aSVNClass classMethods collect: [:each |
		each fileName].
	expectedclassMethodSelectors := aClass class methodDict collect: [:each |
		each selector asString replaceAll: $: with: $#].
	self assert: classMethodSelectors asSet = expectedclassMethodSelectors asSet.! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/24/2008 00:11'!
classPropertiesForTests

	| cr |
	cr := String cr.
	^ 'Instance side' , cr , SVNDummy superclass asString , cr ,
	SVNDummy category asString , cr ,
	(self createStringFromCollection: SVNDummy instVarNames) , cr ,
	(self createStringFromCollection: SVNDummy classVarNames) , cr , cr ,
	'Class side' , cr , 
	(self createStringFromCollection: SVNDummy class instVarNames)! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/24/2008 00:25'!
configureSVNClass: svnClass forLoadingClassNamed: aString 
	
	svnClass
		theName: aString;
		superclassName: 'Object';
		instanceVariables: 'a';
		classVariables: 'A';
		classInstanceVariables: 'b';
		comment: '';
		category: self class category.! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/24/2008 02:09'!
prepareReadTestForClassNamed: className

	| pathToClass |
	pathToClass := self pathForTests , FileDirectory slash , className.
	(FileDirectory on: pathToClass) assureExistence.
	self flag: #TODO. "Mapping details are assumed here. Is that good?"
	self
		inFile: pathToClass, FileDirectory slash , 'comment'
		write: SVNDummy comment.
	self
		inFile: pathToClass, FileDirectory slash , 'properties'
		write: self classPropertiesForTests.
	(FileDirectory on: pathToClass , FileDirectory slash, 'instance') assureExistence.	
	(FileDirectory on: pathToClass , FileDirectory slash, 'class') assureExistence.	! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rkrk 2/24/2008 13:08'!
testAllClassMethodsExists

	| sut expectedFileNames class svnDirectory classDirectory directoryOfMethods actualFileNames |
	class := SVNDummy.
	sut := SVNClass forExistingClass: class.
	svnDirectory := self defaultSVNDirectory.
	sut storeIn: svnDirectory.
	classDirectory := (svnDirectory getSubDirectoryNamed: class name asString).
	self flag: #TODO. "Mapping implementation is spread here..."
	directoryOfMethods := (classDirectory getSubDirectoryNamed: 'class').
	self assert: directoryOfMethods notNil.
	expectedFileNames := (class class methodDict collect: [:each |
		each selector asString replaceAll: $: with: $#]) asSet.
	actualFileNames := directoryOfMethods files collect: [:each | each theName].
	self assert: expectedFileNames = actualFileNames.! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rkrk 2/24/2008 13:07'!
testAllInstanceMethodsExists

	| sut expectedFileNames class svnDirectory classDirectory directoryOfMethods actualFileNames |
	class := SVNDummy.
	sut := SVNClass forExistingClass: class.
	svnDirectory := self defaultSVNDirectory.
	sut storeIn: svnDirectory.
	classDirectory := (svnDirectory getSubDirectoryNamed: class name asString).
	self flag: #TODO. "Mapping implementation is spread here..."
	directoryOfMethods := (classDirectory getSubDirectoryNamed: 'instance').
	self assert: directoryOfMethods notNil.

	expectedFileNames := (class methodDict collect: [:each |
		each selector asString replaceAll: $: with: $#]) asSet.
	actualFileNames := directoryOfMethods files collect: [:each | each theName].
	self assert: expectedFileNames = actualFileNames.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 21:43'!
testCreatingForExistingClassInitializesSVNClassCorrectly

	| sut class |
	class := SVNDummy.
	sut := SVNClass forExistingClass: class.
	self
		assertSVNClass: sut
		hasStateFromSystemClass: class.! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'rkrk 2/24/2008 00:10'!
testCreatingForSerializedClassInitializesSVNClassCorrectly

	| sut class classFilesCreator svnDirectory classDirectory |
	class := SVNDummy.
	classFilesCreator := SVNClass forExistingClass: class.
	svnDirectory := self defaultSVNDirectory.
	classFilesCreator storeIn: svnDirectory.
	classDirectory := (svnDirectory getSubDirectoryNamed: class name asString).
	sut := SVNClass forSerializedClassIn: classDirectory.
	self
		assertSVNClass: sut
		hasStateFromSystemClass: class.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 13:31'!
testEqual

	| class sut1 sut2 |
	class := SVNDummy.
	sut1 := SVNClass forExistingClass: class.
	sut2 := SVNClass forExistingClass: class.
	self assert: sut1 = sut2.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/25/2008 02:15'!
testGetSVNMethodsFromClass

	| sut class expectedInstanceMethods expectedClassMethods |
	class := SVNDummy.
	sut := SVNClass forExistingClass: class.
	expectedInstanceMethods := class methodDict collect: [:each |
		SVNMethod forExistingMethod: each].
	expectedClassMethods := class class methodDict collect: [:each |
		SVNMethod forExistingMethod: each].
	self assert: sut methods = expectedInstanceMethods asSet.
	self assert: sut classMethods = expectedClassMethods asSet.! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'rkrk 2/25/2008 16:14'!
testLoadClass
	
	| sut className |
	sut := SVNClass new.
	className := 'SVNDummy99'.
	self
		configureSVNClass: sut
		forLoadingClassNamed: 'SVNDummy99'.
	[sut load.
	self assert: (Smalltalk hasClassNamed: className).
	self flag: #TODO. "Test for the correct initialization of
	variables and comment	of the created class!!"
	] ensure: [ Smalltalk
				at: className
				ifPresent: [:class | class removeFromSystemUnlogged]].! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 13:32'!
testNotEqual

	| sut1 sut2 |
	sut1 := SVNClass forExistingClass: SVNDummy.
	sut2 := SVNClass forExistingClass: self class.
	self deny: sut1 = sut2.! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rt 2/29/2008 02:58'!
testWriteClassDetailsFile

	"| sut svnDirectory expectedFileName createdFile |
	sut := SVNClass forExistingClass: SVNDummy.
	svnDirectory := self defaultSVNDirectory.
	sut storeClassDetailsIn: svnDirectory.
	expectedFileName := 'properties'.
	self assert: (svnDirectory fileExists: expectedFileName).
	createdFile := svnDirectory getFileNamed: expectedFileName.
	self assert: self classPropertiesForTests = createdFile content."! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rkrk 2/24/2008 01:09'!
testWriteCommentFile

	| sut svnDirectory expectedFileName createdFile |
	sut := SVNClass forExistingClass: SVNDummy.
	svnDirectory := self defaultSVNDirectory.
	sut storeCommentIn: svnDirectory.
	expectedFileName := sut nameForCommentFile.
	self assert: (svnDirectory fileExists: expectedFileName).
	createdFile := svnDirectory getFileNamed: expectedFileName.
	self assert: SVNDummy comment = createdFile content.! !

SVNTestCase subclass: #SVNClientTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientTest subclass: #SVNClientExternalTest
	instanceVariableNames: 'repositoryPath workingCopyPath fileToAdd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientExternalTest subclass: #SVNCApiClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:46'!
setUp

	super setUp.
	sut := SVNCApiClient new.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/8/2008 00:54'!
testGetHeadRevision

	self assert: (sut svnGetHeadRevision: workingCopyPath) = 0. ! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'pe 2/26/2008 09:54'!
testSVNAdd
	| path |
	path := workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self assertPath: workingCopyPath includesFile: fileToAdd! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'pe 2/22/2008 12:33'!
testSvnAddPropertyWithValueTo

	| path fstream propertyPath propertiesContents|
	path := workingCopyPath , self slash , fileToAdd.
	propertyPath := FileDirectory on: workingCopyPath , FileDirectory slash ,'.svn', FileDirectory slash, 'props'.
	sut svnAdd: path.
	sut svnAddProperty: 'propertyName' WithValue: 'value' To: path.
	
	fstream := propertyPath readOnlyFileNamed: 'testFile.svn-work'.
	propertiesContents := fstream contents.
	fstream close.
	
	self assert: (propertiesContents includesSubString: 'propertyName').
	self assert: (propertiesContents includesSubString: 'value').
	! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'test 2/27/2008 14:42'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory repositoryURLPath |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutHeadRevisionFrom: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'test 2/27/2008 16:08'!
testSvnCheckoutRevisionByNumber

	| workingcopyDirectory repositoryURLPath secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutRevisionByNumber: 1 from: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'test 2/25/2008 00:37'!
testSvnCommit

	| path startRevision endRevision |
	path := workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: {path , self slash , fileToAdd}.

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 2/29/2008 02:58'!
testSvnGetPropertyFrom

	"| path property properties |
	
	path := workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	sut svnAddProperty: 'propertyName' WithValue: 'value' To: path.
	properties := sut svnGetPropertiesFrom: path.
	property := properties
		at: 'propertyName'
		ifAbsent: [self assert: false].
	
	self assert: (property = 'value').	"! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 23:49'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory pathToFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: {workingCopyPath}.
	
	"check if succeeded"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 23:46'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile pathToFile pathToSecondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	"create new revisions"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.
	
	secondFile := 'fileForSecondRevision'.
	pathToSecondFile := self pathTo: secondFile inDir: workingCopyPath.
	self createFile: pathToSecondFile.
	sut svnAdd: pathToSecondFile.
	sut svnCommit: {pathToSecondFile}.

	"recover the first revision"
	sut 
		svnUpdateTargets: {workingCopyPath}
		toRevisionByNumber: 1.

	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile)! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createFile: fullPathOfFile

	(FileStream newFileNamed: fullPathOfFile) close.! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rt 2/22/2008 13:41'!
createRepository
	
	self assert: (FileDirectory isLegalFileName: repositoryPath).
	self deny: (FileDirectory on: repositoryPath , self slash) exists.
	
	self executeViaOSProcessSynchronously: 'svnadmin create "' , repositoryPath ,'"'.! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rt 2/22/2008 13:50'!
createWorkingCopy

	| repositoryURLPath |
	self assert: (FileDirectory on: repositoryPath , self slash) exists.
	self deny: (FileDirectory on: workingCopyPath) exists.
	
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	self executeViaOSProcessSynchronously: 'svn co ' , repositoryURLPath , ' "' , workingCopyPath , '"'! !

!SVNClientExternalTest methodsFor: 'running' stamp: 'test 2/27/2008 13:53'!
setUp

	super setUp.
	repositoryPath := self pathForTests , self slash , 'repository'.
	workingCopyPath := self pathForTests , self slash , 'workingCopy'.
	self
		createRepository;
		createWorkingCopy.
	fileToAdd := 'testFile'.
	self createFile: workingCopyPath , self slash , 'testFile'.! !

SVNClientExternalTest subclass: #SVNCommandLineClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCommandLineClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:41'!
setUp

	super setUp.
	sut := SVNCommandLineClient new.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'pe 2/26/2008 13:25'!
testCommandForAddProperty


	| key value path result expected |
	sut := SVNCommandLineClient new.
	key := 'irgendEinKey'.
	value := 'irgendEinValue'.
	path := SmalltalkImage current imagePath.
	result := sut buildCmdPropset: key value: value for: path.
	expected := 'svn propset ' , key , ' ' , value , ' ' , path.
	self assert: result = expected.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'pe 2/26/2008 09:49'!
testSVNAdd
	| path |
	path := workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self assertPath: workingCopyPath includesFile: fileToAdd! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 16:47'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory repositoryURLPath |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutHeadRevisionFrom: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 17:00'!
testSvnCheckoutRevisionByNumber

	| workingcopyDirectory repositoryURLPath secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutRevisionByNumber: 1 from: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:41'!
testSvnCommit

	| path startRevision endRevision |
	path := workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: (Array with: path , self slash , fileToAdd).

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 17:13'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: (Array with: workingCopyPath).
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 17:08'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut svnUpdateTargets: (Array with: workingCopyPath) toRevisionByNumber: 1.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

SVNClientExternalTest subclass: #SVNCreateNewProjectAndCommitTest
	instanceVariableNames: 'repositoryURL className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-AcceptanceTests'!

!SVNCreateNewProjectAndCommitTest methodsFor: 'as yet unclassified' stamp: 'rkrk 2/25/2008 02:40'!
setUp

	super setUp.
	repositoryURL := FileDirectory urlForFileNamed: repositoryPath.
	className := 'SVNTestClassCreatedInAcceptanceTest'.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'as yet unclassified' stamp: 'rkrk 2/25/2008 02:41'!
tearDown

	super tearDown.
	Smalltalk
		at: className asSymbol
		ifPresent: [:class | class removeFromSystemUnlogged].! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'as yet unclassified' stamp: 'rt 2/29/2008 02:45'!
test

	| svnProject workingCopyDirectory newSVNProject svnClass newWorkingCopyDirectory newWorkingCopyPath |
	"create and modify a SVNProject"
	svnClass := SVNClass
		name: className
		superclassName: 'Object'
		instanceVariables: {}
		classVariables: Set new
		classInstanceVariables: {}
		comment: ''
		category: self class category.
	svnProject := SVNProject named: 'TestProject'.
	svnProject addSVNClass: svnClass.
	"define a working copy directory"
	workingCopyDirectory := SVNDirectory on: workingCopyPath.
	svnProject workingCopyDirectory: workingCopyDirectory.
	"commit the changes"
	svnProject repositoryURL: repositoryURL. "Not needed!!"
	svnProject commit.
	"self halt."
	"delete project and working copy"
	svnProject unload.
	self deny: (Smalltalk hasClassNamed: className).
	"checkout the project in a new working copy"
	newWorkingCopyPath := self pathForTests , self slash , 'newWorkingCopy'.
	newWorkingCopyDirectory := SVNDirectory on: newWorkingCopyPath.
	newSVNProject := SVNProject
		checkoutProject: 'TestProject' 
		fromURL: repositoryURL
		inWorkingCopy: newWorkingCopyDirectory.
	"load it into the system"
	newSVNProject load.
	"check if the old state is restored"
	self assert: (Smalltalk hasClassNamed: className).
	self flag: #TODO. "Check if methods are there"! !

SVNClientExternalTest subclass: #SVNFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNFileTest methodsFor: 'assertion' stamp: 'rkrk 2/27/2008 02:00'!
assertThatProperties: propertyDict areAddedTo: svnDirectoryEntry

	| client |
	client := SVNCApiClient new.
	self assert: (propertyDict = (client svnGetPropertiesFrom: svnDirectoryEntry path)).! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/27/2008 02:01'!
testReadFileContents

	| fileName content fullPath |
	fileName := 'someSVNFile'.
	sut := SVNFile 
		named: fileName
		basePath: self pathForTests.
	self assert: sut content isEmpty.
	content := 'blabla' , String cr , 'blupf blupf'.
	fullPath := self pathTo: fileName inDir: self pathForTests.
	self 
		inFile: fullPath
		write: content.
	sut read.
	self assert: sut content = content! !

!SVNFileTest methodsFor: 'tests' stamp: 'rt 2/29/2008 02:57'!
testReadFileProperties

	"| fileName helper key value cmdLineClient expected |
	""setup""
	fileName := 'someSVNFile'.
	helper := SVNFile 
		named: fileName
		basePath: workingCopyPath.
	key := 'schluessel'.
	value := 'wert'.
	helper store.	

	cmdLineClient := SVNCApiClient new.
	cmdLineClient svnAddProperty: key WithValue:value To: helper path.
	
	sut := SVNFile 
		named: fileName
		basePath: workingCopyPath.
	sut read.
	expected := Dictionary with: key -> value.
	self assert: sut properties = expected."! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/27/2008 01:37'!
testReadNonExistingFile

	| fileName |
	fileName := 'someSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self should: [sut read] raise: Error .! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/27/2008 01:37'!
testStoreAndAddFile

	| fileName |
	fileName := 'testSVNFile'.
	sut := SVNFile named: fileName basePath: workingCopyPath.
	sut store.
	self assertThatFiles: {fileName}
		existsIn: workingCopyPath.
	self assertPath: workingCopyPath includesFile: fileName! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 20:29'!
testStoreAsFile

	| sut fileName |
	fileName := 'testSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut store.
	self assertThatFiles: {fileName} existsIn: self pathForTests.! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 20:29'!
testStoreContent

	| sut fileName content |
	fileName := 'otherSVNFile'.
	content := 'this is content' , String cr , 'much content'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	sut store.
	self
		assertThatFile: fileName
		inPath: self pathForTests
		hasContent: content.! !

!SVNFileTest methodsFor: 'tests' stamp: 'rt 2/29/2008 02:53'!
testStoreProperties

	"| fileName propertyDict |
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: workingCopyPath.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	self
		assertThatProperties: propertyDict
		areAddedTo: sut."! !

!SVNClientTest methodsFor: 'running' stamp: 'rkrk 2/24/2008 23:55'!
setUp

	super setUp.
	sut := SVNClient new.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 10:54'!
testBackslashToSlash

	| validPath |
	validPath := sut normalizePath: 'C:\test\test'.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:43'!
testCommandLineNormalizePathInsertsQuotationMarks

	| string expected result |
	sut := SVNCommandLineClient new.
	string := 'blabla/blabla'.
	expected := '"' , string , '"'.
	result := sut normalizePath: string.
	self assert: expected = result.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 11:17'!
testRemoveDoubbleBackslash

	| validPath |
	validPath := sut normalizePath: 'C:\\test\test'.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 10:59'!
testRemoveLastSlash

	| path |
	path := sut normalizePath: 'C:\test\test\'.
	self assert: path = 'C:/test/test'.! !

SVNTestCase subclass: #SVNDirectoryTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNDirectoryTest methodsFor: 'running' stamp: 'rkrk 2/23/2008 01:47'!
setUp

	super setUp.
	sut := SVNDirectory
		named: 'svnDirectoryWhichIsTested'
		basePath: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/22/2008 13:47'!
testCreateFile

	| sut fileName expectedFile resultFile |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'aNewFile'.
	sut createFileNamed: fileName.
	expectedFile := SVNFile  
		named: fileName
		basePath: sut path.
	self assert: sut files size = 1.
	resultFile := sut files someElement.
	self assert: expectedFile = resultFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:48'!
testCreateSubDirectory

	| subDirectoryName expectedDirectory resultDirectory |
	subDirectoryName := 'subDirectory'.
	sut createSubDirectoryNamed: subDirectoryName.
	expectedDirectory := SVNDirectory 
		named: subDirectoryName
		basePath: sut path.
	self assert: sut subdirectories size = 1.
	resultDirectory := sut subdirectories someElement.
	self assert: expectedDirectory = resultDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/25/2008 00:19'!
testCreateWithOn

	sut := SVNDirectory on: self pathForTests.
	FileDirectory
		splitName: self pathForTests
		to: [:dirPath :localName |
			self assert: sut basePath = dirPath.
			self assert: sut theName = localName].
	! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:50'!
testDirectoryExists

	| directoryName |
	directoryName := 'iAmADirectory'.
	sut createSubDirectoryNamed: directoryName.
	self assert: (sut directoryExists: directoryName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:32'!
testFileExists

	| fileName |
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	self assert: (sut fileExists: fileName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/25/2008 16:12'!
testGatherPathsOfAllElements

	| dirName fileName expected |
	dirName := 'dir1'.
	fileName := 'file1'.
	sut
		createSubDirectoryNamed: dirName;
		createFileNamed: fileName.
	expected := Set
		with: sut path , self slash , dirName
		with: sut path , self slash , fileName.
	self assert: sut recursivelyGatherPathsOfAllElements asSet = expected.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:36'!
testGetFileNamed

	| fileName svnFile |
	fileName := 'iAmAFile'.
	svnFile := sut createFileNamed: fileName.
	self assert: (sut getFileNamed: fileName) = svnFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:53'!
testGetSubDirectoryNamed

	| directoryName svnDirectory |
	directoryName := 'iAmADirectory'.
	svnDirectory := sut createSubDirectoryNamed: directoryName.
	self assert: (sut getSubDirectoryNamed: directoryName) = svnDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:49'!
testReadExistingDirectory

	self
		createDirNamed: sut theName
		in: sut basePath.
	self shouldnt: [sut read] raise: Error .! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:50'!
testReadNonExistingDirectory

	self should: [sut read] raise: Error .! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:13'!
testRecursiveReadOnlyWithDirectories

	| subDirPath subDirName subSubDirPath subSubDirName expectedSVNSubDirectory |
	"1st level. Create real directory for the topmost SVNDirectory."
	subDirPath := self createDirNamed: sut theName in: sut basePath.
	"2nd level. Create a directory in the topmost SVNDirectory"
	subDirName := 'subdir'.
	subSubDirPath := self createDirNamed: subDirName in: subDirPath.
	"3rd level. Create a subdirectoy to the directory created just now. "
	subSubDirName := 'subsubdir'.
	self createDirNamed: subSubDirName in: subSubDirPath.
	
	"Now create the equivalent SVNDirectories"
	expectedSVNSubDirectory := SVNDirectory
		named: subDirName
		basePath: subDirPath.
	expectedSVNSubDirectory createSubDirectoryNamed: subSubDirName.
	
	sut read.
	
	self assert: sut subdirectories size = 1.
	self assert: (sut subdirectories includes: expectedSVNSubDirectory).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 23:47'!
testRecursiveReadOnlyWithFiles

	| fileName content pathToFile expectedSvnFile |
	"Create real directory"
	self
		createDirNamed: sut theName
		in: sut basePath.
	"Create a file"
	fileName := 'someFile'.
	content := 'blupfi'.
	pathToFile := self pathTo: fileName inDir: sut path.
	self inFile: pathToFile write: content.
	"Create SVNFile equivalent"
	expectedSvnFile := SVNFile 
		named: fileName
		basePath: sut path
		content: content.
	"exercise"
	sut read.
	self assert: (sut files includes: expectedSvnFile)! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:18'!
testStoreDirectory

	sut store.
	self
		assertThatDirectories: {sut theName}
		existsIn: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:19'!
testStoreDirectoryWithFile

	| fileName |
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut store.
	self
		assertThatFiles: {fileName}
		existsIn: sut path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/25/2008 01:31'!
testStoreLotsOfDirectoriesAndFiles

	| fileName subDirName subDirFileName subSubDirName subSubDirFileName subDir subSubDir |
	fileName := 'file'.
	subDirName := 'subDir'.
	subDirFileName := 'subDirFileName'.
	subSubDirName := 'subsubDir'.
	subSubDirFileName := 'subSubDirFileName'.

	sut createFileNamed: fileName.
	subDir := sut createSubDirectoryNamed: subDirName.
	subDir createFileNamed: subDirFileName.
	subSubDir := subDir createSubDirectoryNamed: subSubDirName.
	subSubDir createFileNamed: subSubDirFileName.
	
	sut store.
	self assertThatFiles: {fileName. subDirName} existsIn: sut path.
	self assertThatFiles: {subDirFileName. subSubDirName} existsIn: subDir path.
	self assertThatFiles: {subSubDirFileName} existsIn: subSubDir path.! !

SVNTestCase subclass: #SVNMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNMethodTest methodsFor: 'running' stamp: 'rkrk 2/24/2008 00:29'!
tearDown

	super tearDown.
	SVNDummy methodDict
		at: #m2
		ifAbsent: [SVNDummy compile: SVNDummy sourceCodeForM2]! !

!SVNMethodTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 01:32'!
testEquals

	| methodBlock method1 method2 |
	methodBlock := [SVNMethod forExistingMethod: SVNDummy >> #m1].
	method1 := methodBlock value.
	method2 := methodBlock value.
	self assert: method1 ~~ method2.
	self assert: method1 = method2! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/24/2008 12:44'!
testExtractMetaClass

	| method result svnFile className |
	method := SVNMethod new.
	self flag: #TODO. "Implicitly specified mapping..."
	svnFile := SVNFile
		named: 'm99'
		basePath: '/'.
	className := 'SVNDummy class'.
	svnFile properties
		at: 'class'
		put: className.
	result := method extractClassFrom: svnFile.
	self assert: result = className.! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/24/2008 23:09'!
testLoadMethodIntoSystem

	| class methodSelector sut |
	class := SVNDummy.
	methodSelector := #m2.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	class removeSelector: methodSelector.
	self deny: (class methodDict includesKey: methodSelector).
	sut load.
	self assert: (class methodDict includesKey: methodSelector).! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/25/2008 02:18'!
testRestoreFromSVNFile

	
	| methodSelector class methodReference svnFile sut expectedSVNMethod |
	"prepare"
	methodSelector := #methodWithSpecialCharacter:.
	class := SVNDummy.
	methodReference := (class >> methodSelector) methodReference.
	svnFile := SVNFile 
		named: methodSelector asString
		basePath: ''
		content: methodReference source.
	svnFile properties 
		at: 'class'
		put: class name asString.
	svnFile properties 
		at: 'category'
		put: methodReference category.
	svnFile properties 
		at: 'timestamp'
		put: methodReference timeStamp.
	"exercise"
	sut := SVNMethod restoreFrom: svnFile.
	"expected"
	expectedSVNMethod := SVNMethod forExistingMethod: class >> methodSelector.
	"assertion"
	self assert: sut = expectedSVNMethod! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 2/24/2008 23:00'!
testStoreInSVNDirectory
	
	| svnDir methodFile methodSelector class sut methodReference expectedSVNFile expectedFileName |
	"prepare"
	methodSelector := #methodWithSpecialCharacter:.
	class := SVNDummy.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	svnDir := self defaultSVNDirectory.
	"exercise"
	sut storeIn: svnDir.
	"expected"
	methodReference := (class >> methodSelector) methodReference.
	expectedFileName := methodSelector asString 
		replaceAll: $:
		with: $#.
	expectedSVNFile := SVNFile 
		named: expectedFileName asString
		basePath: svnDir path
		content: methodReference source.
	expectedSVNFile properties 
		at: 'class'
		put: class name asString.
	expectedSVNFile properties 
		at: 'category'
		put: methodReference category.
	expectedSVNFile properties 
		at: 'timestamp'
		put: methodReference timeStamp.
	"assertion"
	methodFile := svnDir getFileNamed: sut fileName.
	self assert: methodFile notNil.
	self assert: methodFile = expectedSVNFile! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 2/24/2008 23:00'!
testStoreThenRestore

	| methodName writtenSVNMethod svnDirectory methodFile readSVNMethod |
	"prepare"
	methodName := 'm1'.
	writtenSVNMethod := SVNMethod forExistingMethod: SVNDummy >> methodName asSymbol.
	svnDirectory := self defaultSVNDirectory.
	"exercise"
	writtenSVNMethod storeIn: svnDirectory.
	"assertion"
	methodFile := svnDirectory getFileNamed: methodName.
	self assert: methodFile notNil.
	readSVNMethod := SVNMethod restoreFrom: methodFile.
	self assert: writtenSVNMethod = readSVNMethod! !

SVNTestCase subclass: #SVNProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNProjectTest methodsFor: 'assertion' stamp: 'rkrk 2/25/2008 02:08'!
assertExistanceOfProject: aSVNProject in: pathString

	| dir |
	dir := FileDirectory on: pathString.
	self assert: (dir directoryExists: aSVNProject theName).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 12:35'!
testAddClass

	| sut aClass methodsOfClass result |
	sut := SVNProject new.
	aClass := SVNDummy.
	sut addClass: aClass.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: aClass)).
	methodsOfClass := aClass methodDict collect: [ : ea | SVNMethod forExistingMethod: ea ].
	result := sut allVersionedMethods asSet.
	self assert: result = methodsOfClass asSet! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 12:38'!
testAddMethod

	| sut aMethod svnMethod |
	sut := SVNProject new.
	aMethod := SVNDummy >> #m1.
	sut addMethod: aMethod.
	self assert: sut versionedMethods size = 1.
	svnMethod := sut versionedMethods someElement.
	self assert: svnMethod nameOfClass = aMethod methodReference actualClass name.
	self assert: svnMethod methodSelector = aMethod selector! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/25/2008 01:58'!
testMappingToFileSystem01

	| sut |
	sut := SVNProject named: 'SVNProjectWhichIsSerialized'.
	sut storeIn: self defaultSVNDirectory.
	self 
		assertExistanceOfProject: sut
		in: self pathForTests! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 00:54'!
testMappingToFileSystem02
	| sut |
	self flag: #TODO.	"Add SVNElements"
	sut := SVNProject named: 'SVNProjectWhichIsSerialized'.
	sut storeIn: self defaultSVNDirectory.
	self 
		assertExistanceOfProject: sut
		in: self pathForTests! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/25/2008 02:04'!
testRestore

	| sut directory projectName class storedProject |
	directory := self defaultSVNDirectory.
	projectName := 'SomeSVNProject'.
	class := SVNDummy.
	storedProject := SVNProject named: projectName.
	storedProject addClass: class.
	storedProject storeIn: directory.
	
	sut := SVNProject restoreFrom: (directory getSubDirectoryNamed: projectName).
	self assert: sut theName = projectName.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: class)).! !

!SVNTestCase methodsFor: 'assert' stamp: 'pe 2/26/2008 09:48'!
assertPath: path includesFile: fileName 
	| svnDir wcEntries wcEntriesContents |
	self flag: #Todo.
	svnDir := FileDirectory on: path , FileDirectory slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	wcEntriesContents := wcEntries contents.
	wcEntries close.
	self assert: (wcEntriesContents includesSubString: fileName)! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 20:48'!
assertThatDirectories: dirNames existsIn: path

	dirNames do: [:each |
		self assert: ((FileDirectory on: path) directoryExists: each)] .! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/24/2008 23:48'!
assertThatFile: fileName inPath: pathName hasContent: expectedContent 

	| fullPath actualContent |
	fullPath := self pathTo: fileName inDir: pathName.
	self assert: (FileStream isAFileNamed: fullPath).
	actualContent := (FileStream readOnlyFileNamed: fullPath) contentsOfEntireFile.
	self assert: actualContent = expectedContent! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/25/2008 01:29'!
assertThatFiles: fileNames existsIn: path

	| dir |
	fileNames do: [:each |
		dir := FileDirectory on: path.
		self assert: ((dir fileExists: each) or: [(dir directoryExists: each)])] .! !

!SVNTestCase methodsFor: 'assert' stamp: 'pe 2/26/2008 09:42'!
assertWorkingCopyIncludesFile: fileName

	| svnDir wcEntries wcEntriesContents |
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: workingCopyPath , FileDirectory slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	wcEntriesContents := wcEntries contents.
	wcEntries close.
	self assert: (wcEntriesContents includesSubString: fileName).! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/21/2008 21:50'!
createDirNamed: newDirName in: existingDir 
	
	(FileDirectory on: existingDir) assureExistenceOfPath: newDirName.
	^ existingDir , FileDirectory slash , newDirName.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/21/2008 16:41'!
createStringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNTestCase methodsFor: 'please change me' stamp: 'rkrk 2/22/2008 14:49'!
defaultSVNDirectory
	
	^ SVNDirectory
		named: 'svnTests'
		basePath: SmalltalkImage current imagePath! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:30'!
ensureThatFileNotExist: fileName

	FileDirectory deleteFilePath: fileName! !

!SVNTestCase methodsFor: 'OSProcess' stamp: 'rkrk 2/7/2008 13:51'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [p := ExternalOSProcess command: command.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 10) wait]].! !

!SVNTestCase methodsFor: 'write files' stamp: 'test 2/12/2008 12:36'!
inFile: pathToFile write: aString

	(FileStream forceNewFileNamed: pathToFile)
		nextPutAll: aString;
		close.

	! !

!SVNTestCase methodsFor: 'default' stamp: 'cop 2/12/2008 11:24'!
pathForTests

	"If you touch the path, reset it before commit!!'"
	^ SmalltalkImage current imagePath , FileDirectory slash , 'svnTests'! !

!SVNTestCase methodsFor: 'write files' stamp: 'rkrk 2/24/2008 23:45'!
pathTo: filename inDir: pathToDirectory

	^ pathToDirectory , self slash , filename! !

!SVNTestCase methodsFor: 'read files' stamp: 'cop 2/5/2008 11:33'!
readFileFrom: aDir fileName: aString

	| stream contents |
	stream := aDir oldFileNamed: aString.
	contents := stream contents.
	stream close.
	^contents! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 2/23/2008 23:45'!
restoreSVNDummy

	"Read a file out of SVNDummy. If you change the class, replace this fileout."
	| stream |
	stream :=  ReadWriteStream with: '''From Squeak3.9 of 7 November 2006 [latest update: #7067] on 23 February 2008 at 11:10:05 pm''!!
Object subclass: #SVNDummy
	instanceVariableNames: ''i1 i2''
	classVariableNames: ''C1 C2''
	poolDictionaries: ''''
	category: ''SqueakSVN-Base-Test''!!
!!SVNDummy commentStamp: ''<historical>'' prior: 0!!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!!


!!SVNDummy methodsFor: ''dummy methods'' stamp: ''test 2/23/2008 11:54''!!
m1
	^ 1!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''timestamp''!!
m2
	^ 2!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''cop 2/7/2008 19:50''!!
methodWithSpecialCharacter: aString
	^ aString!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

SVNDummy class
	instanceVariableNames: ''IC1 IC2''!!

!!SVNDummy class methodsFor: ''dummy'' stamp: ''cop 2/7/2008 19:50''!!
m3

	^ 3!! !!


!!SVNDummy class methodsFor: ''convenience'' stamp: ''cop 2/7/2008 19:50''!!
sourceCodeForM2
	^ ''m2
	^ 2''!! !!
'.
	stream
		reset;
		fileInAnnouncing: 'Restoring SVNDummy';
		close.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 2/12/2008 14:59'!
setUp

	super setUp.
	(FileDirectory on: self pathForTests) assureExistence.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:24'!
slash

	^ FileDirectory slash! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 2/3/2008 22:43'!
tearDown

	super tearDown.
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [(FileDirectory on: self pathForTests) recursiveDelete]
		ifTrue: [self executeViaOSProcessSynchronously: 'delete_svnTests.bat'].! !
